# -*- coding: utf-8 -*-
"""
Spyder Editor

This is a temporary script file.
PYTHON PROGRAM

GRAB ALL VALUES OF EACH HAND GESTURE
GET A MEAN AND STD (ONE PER CHANNEL)
IF SD IS 0 THEN ASSIGN “1” TO THE FINAL VALUE
ELSE, USE FORMULA
"""

import numpy as np
import matplotlib.pyplot as plt
import pandas as pd
from collections import Counter

def formula(mean, sd, num):
  return ((1)/(np.sqrt(2*np.pi)*sd)) * (np.exp(-np.square(num-mean)/(2*np.square(sd))))

def getVal(means, sd, num):
    val = 1.0
    for ch in range(0, 8):
        if (sd[ch] == 0):
            val = val * 1
        else:
            val = val * (formula(means[ch], sd[ch], num[ch]))
    return val
#importing the data       
df = pd.read_csv("/Users/jose_montalvo/Desktop/Training_Data.csv")
colName = df.columns #all names of the categories
#print(colName)

ones = []*0

counter = 0

#row, col gets the value
#print(df.at[0,"Class"])

c1_Ch1 = [] #Class1_Channel1
c1_Ch2 = [] #Class1_Channel2
c1_Ch3 = [] #Class1_Channel3
c1_Ch4 = [] #Class1_Channel4
c1_Ch5 = [] #Class1_Channel5
c1_Ch6 = [] #Class1_Channel6
c1_Ch7 = [] #Class1_Channel7
c1_Ch8 = [] #Class1_Channel8

c2_Ch1 = [] #Class2_Channel1
c2_Ch2 = [] #Class2_Channel2
c2_Ch3 = [] #Class2_Channel3
c2_Ch4 = [] #Class2_Channel4
c2_Ch5 = [] #Class2_Channel5
c2_Ch6 = [] #Class2_Channel6
c2_Ch7 = [] #Class2_Channel7
c2_Ch8 = [] #Class2_Channel8

c3_Ch1 = [] #Class3_Channel1
c3_Ch2 = [] #Class3_Channel2
c3_Ch3 = [] #Class3_Channel3
c3_Ch4 = [] #Class3_Channel4
c3_Ch5 = [] #Class3_Channel5
c3_Ch6 = [] #Class3_Channel6
c3_Ch7 = [] #Class3_Channel7
c3_Ch8 = [] #Class3_Channel8

c4_Ch1 = [] #Class4_Channel1
c4_Ch2 = [] #Class4_Channel2
c4_Ch3 = [] #Class4_Channel3
c4_Ch4 = [] #Class4_Channel4
c4_Ch5 = [] #Class4_Channel5
c4_Ch6 = [] #Class4_Channel6
c4_Ch7 = [] #Class4_Channel7
c4_Ch8 = [] #Class4_Channel8


while(counter < df.shape[0]):
    if(df.at[counter,"Class"] == 1): #if the CLASS is a 1
        #store inn an array of arrays
        c1_Ch1.append(df.at[counter,"Channel 1"])
        c1_Ch2.append(df.at[counter,"Channel 2"])
        c1_Ch3.append(df.at[counter,"Channel 3"])
        c1_Ch4.append(df.at[counter,"Channel 4"])
        c1_Ch5.append(df.at[counter,"Channel 5"])
        c1_Ch6.append(df.at[counter,"Channel 6"])
        c1_Ch7.append(df.at[counter,"Channel 7"])
        c1_Ch8.append(df.at[counter,"Channel 8"])
    if(df.at[counter,"Class"] == 2): #if the CLASS is a 2
        #store inn an array of arrays
        c2_Ch1.append(df.at[counter,"Channel 1"])
        c2_Ch2.append(df.at[counter,"Channel 2"])
        c2_Ch3.append(df.at[counter,"Channel 3"])
        c2_Ch4.append(df.at[counter,"Channel 4"])
        c2_Ch5.append(df.at[counter,"Channel 5"])
        c2_Ch6.append(df.at[counter,"Channel 6"])
        c2_Ch7.append(df.at[counter,"Channel 7"])
        c2_Ch8.append(df.at[counter,"Channel 8"])
    if(df.at[counter,"Class"] == 3): #if the CLASS is a 3
        #store inn an array of arrays
        c3_Ch1.append(df.at[counter,"Channel 1"])
        c3_Ch2.append(df.at[counter,"Channel 2"])
        c3_Ch3.append(df.at[counter,"Channel 3"])
        c3_Ch4.append(df.at[counter,"Channel 4"])
        c3_Ch5.append(df.at[counter,"Channel 5"])
        c3_Ch6.append(df.at[counter,"Channel 6"])
        c3_Ch7.append(df.at[counter,"Channel 7"])
        c3_Ch8.append(df.at[counter,"Channel 8"])
    if(df.at[counter,"Class"] == 4): #if the CLASS is a 4
        #store inn an array of arrays
        c4_Ch1.append(df.at[counter,"Channel 1"])
        c4_Ch2.append(df.at[counter,"Channel 2"])
        c4_Ch3.append(df.at[counter,"Channel 3"])
        c4_Ch4.append(df.at[counter,"Channel 4"])
        c4_Ch5.append(df.at[counter,"Channel 5"])
        c4_Ch6.append(df.at[counter,"Channel 6"])
        c4_Ch7.append(df.at[counter,"Channel 7"])
        c4_Ch8.append(df.at[counter,"Channel 8"])
    counter =  counter + 1


#getting all the means
means_c1 = [] #all means in class 1   
means_c1.append(np.mean(c1_Ch1))
means_c1.append(np.mean(c1_Ch2))
means_c1.append(np.mean(c1_Ch3))
means_c1.append(np.mean(c1_Ch4))
means_c1.append(np.mean(c1_Ch5))
means_c1.append(np.mean(c1_Ch6))
means_c1.append(np.mean(c1_Ch7))
means_c1.append(np.mean(c1_Ch8))

means_c2 = [] #all means in class 2
means_c2.append(np.mean(c2_Ch1))
means_c2.append(np.mean(c2_Ch2))
means_c2.append(np.mean(c2_Ch3))
means_c2.append(np.mean(c2_Ch4))
means_c2.append(np.mean(c2_Ch5))
means_c2.append(np.mean(c2_Ch6))
means_c2.append(np.mean(c2_Ch7))
means_c2.append(np.mean(c2_Ch8))

means_c3 = [] #all means in class 3
means_c3.append(np.mean(c3_Ch1))
means_c3.append(np.mean(c3_Ch2))
means_c3.append(np.mean(c3_Ch3))
means_c3.append(np.mean(c3_Ch4))
means_c3.append(np.mean(c3_Ch5))
means_c3.append(np.mean(c3_Ch6))
means_c3.append(np.mean(c3_Ch7))
means_c3.append(np.mean(c3_Ch8))

means_c4 = [] #all means in class 14 
means_c4.append(np.mean(c4_Ch1))
means_c4.append(np.mean(c4_Ch2))
means_c4.append(np.mean(c4_Ch3))
means_c4.append(np.mean(c4_Ch4))
means_c4.append(np.mean(c4_Ch5))
means_c4.append(np.mean(c4_Ch6))
means_c4.append(np.mean(c4_Ch7))
means_c4.append(np.mean(c4_Ch8))


#getting all the standard deviations
sd_c1 = [] #all standard deviations in class 1   
sd_c1.append(np.std(c1_Ch1))
sd_c1.append(np.std(c1_Ch2))
sd_c1.append(np.std(c1_Ch3))
sd_c1.append(np.std(c1_Ch4))
sd_c1.append(np.std(c1_Ch5))
sd_c1.append(np.std(c1_Ch6))
sd_c1.append(np.std(c1_Ch7))
sd_c1.append(np.std(c1_Ch8))

sd_c2 = [] #all standard deviations in class 2
sd_c2.append(np.std(c2_Ch1))
sd_c2.append(np.std(c2_Ch2))
sd_c2.append(np.std(c2_Ch3))
sd_c2.append(np.std(c2_Ch4))
sd_c2.append(np.std(c2_Ch5))
sd_c2.append(np.std(c2_Ch6))
sd_c2.append(np.std(c2_Ch7))
sd_c2.append(np.std(c2_Ch8))

sd_c3 = [] #all standard deviations in class 3
sd_c3.append(np.std(c3_Ch1))
sd_c3.append(np.std(c3_Ch2))
sd_c3.append(np.std(c3_Ch3))
sd_c3.append(np.std(c3_Ch4))
sd_c3.append(np.std(c3_Ch5))
sd_c3.append(np.std(c3_Ch6))
sd_c3.append(np.std(c3_Ch7))
sd_c3.append(np.std(c3_Ch8))

sd_c4 = [] #all standard deviations in class 4 
sd_c4.append(np.std(c4_Ch1))
sd_c4.append(np.std(c4_Ch2))
sd_c4.append(np.std(c4_Ch3))
sd_c4.append(np.std(c4_Ch4))
sd_c4.append(np.std(c4_Ch5))
sd_c4.append(np.std(c4_Ch6))
sd_c4.append(np.std(c4_Ch7))
sd_c4.append(np.std(c4_Ch8))


print("sd (wieghts) pass by hand for now")
print("")
print(sd_c1)
print(sd_c2)
print(sd_c3)
print(sd_c4)
print("")

print("mean (wieghts) pass by hand for now")
print("")
print(means_c1)
print(means_c2)
print(means_c3)
print(means_c4)
print("")
#calculating 

#test value
num = [196608,196608,196608,	8409645,	196608,196608,196608,200192] #class 1


vals = []

vals.append(getVal(means_c1, sd_c1, num))
vals.append(getVal(means_c2, sd_c2, num))
vals.append(getVal(means_c3, sd_c3, num))
vals.append(getVal(means_c4, sd_c4, num))

#find the largest value
maxVal = 0.0
maxIndex = 0
count = 0
for v in vals:
    if (v>maxVal):
        maxVal = v
        maxIndex = count
    count = count + 1

prediction = maxIndex + 1
print("prediction is:" + str(prediction))




#do this for 2 seconds worth of data, and store each prediction in an array, the mode is the one that actually is


